<template>
  <div class="branch-selector-container">
    <div :class="$style.slideDownContainer">
      <div
        @click="toggleOpened()"
        :class="[
          $style.branchSelector,
          isOpened && $style.isOpened,
          isVipMember && $style.vipTheme
        ]"
      >
        <i :class="$style.iconBranch" />
        <span :class="$style.pleaseSelect">{{ selectTitle }}</span>
        <i :class="['ic-sm-arrow', $style.iconArrow]" />
      </div>
      <transition name="slide-down">
        <ul
          v-if="isOpened"
          :class="[$style.select, isVipMember && $style.vipTheme]"
        >
          <template v-for="(option, index) in options">
            <li
              :key="index"
              v-if="isOptionAvailable(option.groupId)"
              :class="[localValue === option.groupId && $style.isActive]"
              @click="select(option.groupId)"
            >
              {{ $t(`group.${option.groupId}`) }}
            </li>
          </template>
        </ul>
      </transition>
    </div>

    <div
      @click="submit"
      :class="[$style.submit, isVipMember && $style.vipTheme]"
    >
      {{ $t("landing.branchSelector.submit") }}
    </div>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import { preorderAvailable } from "../../utils";

export default {
  props: {
    options: {
      type: Array,
      default: () => []
    },

    value: {
      type: String,
      required: true
    },

    action: {
      type: String,
      required: true
    }
  },

  data() {
    return {
      isOpened: false
    };
  },

  computed: {
    ...mapGetters("account", ["isVipMember"]),
    localValue: {
      get() {
        return this.value;
      },

      set(value) {
        this.$emit("input", value);
      }
    },

    selectTitle() {
      const selected = this.options.find(o => o.groupId === this.localValue);
      return selected
        ? this.$t(`group.${selected.groupId}`)
        : this.$t("landing.branchSelector.pleaseSelect");
    }
  },

  methods: {
    isOptionAvailable(groupId) {
      return (
        this.action === "booking" ||
        (this.action === "preordering" && preorderAvailable(groupId))
      );
    },

    toggleOpened(force) {
      this.isOpened = typeof force === "undefined" ? !this.isOpened : force;
    },

    select(groupId) {
      this.localValue = groupId;
      this.$nextTick(() => {
        this.toggleOpened(false);
      });
    },

    submit() {
      if (this.options.find(o => o.groupId === this.localValue)) {
        this.$emit("submit", this.localValue);
      } else {
        // NOTE: handle not selected.
        console.log("please choose one.");
      }
    }
  }
};
</script>

<style lang="scss" scoped>
.slide-down {
  &-enter-active {
    overflow: hidden;
    transition: max-height 0.5s ease-in-out;
  }
  &-leave-active {
    overflow: hidden;
    transition: max-height 0.5s cubic-bezier(0, 1, 0, 1);
  }

  &-enter,
  &-leave-to {
    max-height: 0;
  }

  &-enter-to,
  &-leave {
    max-height: 1000px;
  }
}
</style>

<style lang="scss" module>
:global(.branch-selector-container) {
  $height-mobile: 44px;
  $height-desktop: 50px;
  $font-size-desktop: 18px;
  $select-width-desktop: 340px;

  $border-radius: 2px;
  $border-width: 0.5px;

  @mixin border() {
    border: $border-width solid $color-pigeon-grey;
  }

  position: relative;

  @include media-breakpoint-up(md) {
    height: $height-desktop;
  }

  .slideDownContainer {
    position: absolute;
    display: inline-block;
    width: 100%;
    border-radius: $border-radius;
    transform: translate3d(0, 0, 0); // fix safari border-radius issue
    overflow: hidden;
    z-index: 2;

    @include media-breakpoint-up(md) {
      top: 0;
      left: 0;
      display: block;
      width: $select-width-desktop;
    }
  }

  .branchSelector {
    @include border();

    width: 100%;
    height: $height-mobile;
    cursor: pointer;
    transform: translate3d(0, 0, 0); // fix safari font rendering issue
    position: relative;
    background: $color-white;
    color: $color-primary-black;

    &.isOpened {
      color: $color-white;
      background: $color-skm-red;
      border-radius: $border-radius $border-radius 0 0;

      .iconBranch {
        background: url(/static/images/ic-branch-active.svg) center no-repeat;
      }

      .iconArrow {
        transform: rotate(180deg);
      }
    }

    @include media-breakpoint-up(md) {
      width: $select-width-desktop;
      height: $height-desktop;
    }
  }

  .submit {
    display: inline-block;
    position: absolute;
    top: 60px;
    left: 0px;
    display: inline-block;
    background: $color-skm-red;
    width: 100%;
    height: $height-mobile;
    line-height: $height-mobile;
    text-align: center;
    font-size: $font-size-desktop;
    color: $color-white;
    border-radius: $border-radius;
    cursor: pointer;

    @include media-breakpoint-up(md) {
      top: 0;
      left: $select-width-desktop;
      margin-left: 20px;
      width: 155px;
      height: $height-desktop;
      line-height: $height-desktop;
      font-size: $font-size-desktop;
    }
  }

  // NOTE: should use svg font.
  .iconBranch {
    float: left;
    display: block;
    height: 100%;
    width: $height-mobile;
    background: url(/static/images/ic-branch.svg) center no-repeat;

    @include media-breakpoint-up(md) {
      width: $height-desktop;
    }
  }

  .iconArrow {
    float: right;
    margin-right: 20px;
    font-size: 10px;
    line-height: $height-mobile - $border-width * 2;
    transition: all 0.3s;

    @include media-breakpoint-up(md) {
      line-height: $height-desktop - $border-width * 2;
    }
  }

  .pleaseSelect {
    float: left;
    line-height: $height-mobile - $border-width * 2;

    @include media-breakpoint-up(md) {
      font-size: $font-size-desktop;
      line-height: $height-desktop - $border-width * 2;
    }
  }

  .select {
    width: 100%;
    padding: 0;
    margin: 0;
    cursor: pointer;
    color: $color-primary-black;
    background: $color-white;
    height: 230px;
    overflow-y: auto;
    border-bottom: 1px solid $color-pigeon-grey;

    li {
      @include border();
      border-top-width: 0;

      padding-left: 20px;
      list-style: none;
      height: $height-mobile;
      line-height: $height-mobile;

      &:last-child {
        border-radius: 0 0 $border-radius $border-radius;
      }

      &.isActive {
        background: $color-skm-red;
        color: $color-white;
      }
    }

    @include media-breakpoint-up(md) {
      top: $height-desktop;
      width: $select-width-desktop;

      li {
        font-size: $font-size-desktop;
        height: $height-desktop;
        line-height: $height-desktop;
      }
    }
  }

  .vipTheme {
    &.select {
      li {
        &.isActive {
          background: $color-skm-gold;
        }
      }
    }
    &.submit,
    &.isOpened {
      background: $color-skm-gold;
    }
  }
}
</style>
